//------------------------------------------------------------------------
//  双一次ｚ変換によるバタワースフィルタの設計（ヘッダ）
//      LPF, HPF のみ
//
//  2023/01/08, Copyright (c) 2023 MIKAMI, Naoki
//------------------------------------------------------------------------

#include <complex>      // 複素数用
#include "Array.hpp"
#include "BiquadV.hpp"

#ifndef BILINEAR_BUTTERWORTH_HPP
#define BILINEAR_BUTTERWORTH_HPP

namespace Mikami
{
    typedef complex<float> Complex; // "Complex" を定義する
    typedef BiquadV::Coefs Coefs;   // "Coefs" を定義する

    class BilinearDesign
    {
    public:
        enum Type { LPF, HPF };

        // コンストラクタ
        BilinearDesign(int order, float fs)
            : PI_(3.1415926536f), PI_FS_(PI_/fs), ORDER_(order),
              sP_(order/2), zP_(order/2), ck_(order/2) {}

        // デストラクタ
        virtual ~BilinearDesign() {}

        // 設計の実行
        void Execute(float fc, Type pb, Coefs c[], float& g);

    private:
        const float PI_;
        const float PI_FS_;
        const int ORDER_;

        Array<Complex> sP_;         // s 平面上の極
        Array<Complex> zP_;         // z 平面上の極
        Array<BiquadV::Coefs> ck_;  // BiquadV の部分の係数
        float gain_;                // 利得定数

        void Butterworth();
        void Bilinear(float fc);
        void ToCascade(Type pb);
        void GetGain(Type pb);
        void GetCoefs(Coefs c[], float& gain) const;
    };
}
#endif  // BILINEAR_BUTTERWORTH_HPP
